﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

namespace Musitters
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
            _form2Instance = this;
            var settings = Properties.Settings.Default;
            if (!string.IsNullOrEmpty((string)settings["AccessToken"]))
            {
                TwitterUser tu = new TwitterUser(settings.ConsumerKey, settings.ConsumerSecret,
                                       settings.AccessToken, settings.AccessTokenSecret,
                                       settings.UserId, settings.ScreenName);
                this.label3.Text = tu.name + " @" + settings.ScreenName;
                this.button3.Text = "認証解除(&A)";
            }
            if (!string.IsNullOrEmpty((string)settings["MusicFolderPath"]))
            {
                string mfp = (string)settings["MusicFolderPath"];
                if (40 < mfp.Length)
                {
                    this.label1.Text = mfp.Substring(0, 40) + "...";
                }
                else
                {
                    label1.Text = mfp;
                }

                
            }

        }

        //Form1オブジェクトを保持するためのフィールド
        private static Form2 _form2Instance;

        //Form1オブジェクトを取得、設定するためのプロパティ
        public static Form2 Form2Instance
        {
            get
            {
                return _form2Instance;
            }
            set
            {
                _form2Instance = value;
            }
        }

        private WMPLib.WindowsMediaPlayer wmp = new WMPLib.WindowsMediaPlayer();

        private void button3_Click(object sender, EventArgs e)
        {
            var settings = Properties.Settings.Default;

            if (string.IsNullOrEmpty((string)settings["AccessToken"]))
            {
                Form3 form = new Form3();
                form.Show();
            }
            else
            {
                button3.Text = "認証する(&A)...";
                settings.AccessToken = "";
                settings.AccessTokenSecret = "";
                settings.UserId = "";
                settings.ScreenName = "";
                settings.Level = 1;
                settings.Save();
                Form1 form1 = Form1.Form1Instance;
                form1.wmp.controls.stop();
                form1.再生ToolStripMenuItem.Visible = true;
                form1.一時停止ToolStripMenuItem.Visible = false;
                form1.NowPlayTimes = 0;
                label3.Text = "";
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            //FolderBrowserDialogクラスのインスタンスを作成
            FolderBrowserDialog fbd = new FolderBrowserDialog();

            //上部に表示する説明テキストを指定する
            fbd.Description = "フォルダを指定してください。";
            //ルートフォルダを指定する
            //デフォルトでDesktop
            var settings = Properties.Settings.Default;
            if (!string.IsNullOrEmpty(settings.MusicFolderPath))
            {
                fbd.SelectedPath = settings.MusicFolderPath;
            }
            else
            {
                fbd.RootFolder = Environment.SpecialFolder.Desktop;
            }
            //最初に選択するフォルダを指定する
            //RootFolder以下にあるフォルダである必要がある
            //fbd.SelectedPath = @"C:\";
            //ユーザーが新しいフォルダを作成できるようにする
            //デフォルトでTrue
            fbd.ShowNewFolderButton = true;

            //ダイアログを表示する
            if (fbd.ShowDialog(this) == DialogResult.OK)
            {
                try
                {
                    ArrayList al = new ArrayList();
                    this.GetAllFiles(fbd.SelectedPath, "*.mp3", ref al);
                    this.GetAllFiles(fbd.SelectedPath, "*.wav", ref al);
                    this.GetAllFiles(fbd.SelectedPath, "*.wma", ref al);
                    this.GetAllFiles(fbd.SelectedPath, "*.3gp", ref al);
                    this.GetAllFiles(fbd.SelectedPath, "*.aac", ref al);

                    if (al.Count == 0)
                    {
                        MessageBox.Show("選択したフォルダに音楽ファイルが見つかりませんでした。別のフォルダを選択してください。");
                    }
                    else
                    {
                        Form1.Form1Instance.musicFileList = al;
                        //選択されたフォルダを表示する
                        settings.MusicFolderPath = fbd.SelectedPath;
                        settings.Save();

                        if (40 < fbd.SelectedPath.Length)
                        {
                            this.label1.Text = fbd.SelectedPath.Substring(0, 40) + "...";
                        }
                        else
                        {
                            this.label1.Text = fbd.SelectedPath;
                        }
                        
                        Form1.Form1Instance.再生ToolStripMenuItem.Enabled = true;
                    }

                }
                catch (UnauthorizedAccessException ex)
                {
                    MessageBox.Show("フォルダのアクセスが拒否されました。別のフォルダを選択してください。");
                }
            }

        }

        private void GetAllFiles(
            string folder, string searchPattern, ref ArrayList files)
        {
            //folderにあるファイルを取得する
            string[] fs =
                System.IO.Directory.GetFiles(folder, searchPattern);
            //ArrayListに追加する
            files.AddRange(fs);

            //folderのサブフォルダを取得する
            string[] ds = System.IO.Directory.GetDirectories(folder);
            //サブフォルダにあるファイルも調べる
            foreach (string d in ds)
                GetAllFiles(d, searchPattern, ref files);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
